-- RBT-TEST - ДПРД для функций
-- Проверка дискреционного разграничения доступа для функций
-- Права доступа для функций: EXECUTE
--
\i 'support/init.sql'
--
-- Подключение пользователя u_0_00
\connect - u_0_00
--
-- Создаем функцию и отбираем права на ее выполнение у PUBLIC
CREATE FUNCTION test (BOOLEAN) RETURNS TEXT AS '
    SELECT CASE WHEN $1 THEN ''success'' ELSE ''fail'' END;
' LANGUAGE sql;
REVOKE ALL ON FUNCTION test (BOOLEAN) FROM PUBLIC;
--
-- Владельцу все действия разрешены
--
-- Попытка вызвать функцию
-- Ожидается успех
SELECT test (true);
--
-- Подключение пользователя u_1_10
\connect - u_1_10
--
-- Попытка вызвать функцию
-- Ожидается ошибка доступа
SELECT test (true);
--
-- Владелец u_0_00 дает право EXECUTE для пользователя u_1_10
\connect - u_0_00
GRANT EXECUTE ON FUNCTION test (BOOLEAN) TO u_1_10;
--
-- Подключение пользователя u_1_10
\connect - u_1_10
--
-- Попытка вызвать функцию
-- Ожидается успех
SELECT test (true);
--
\i 'support/done.sql'
