-- RBT-TEST - ДПРД для табличных пространств
-- Проверка дискреционного разграничения доступа для табличных пространств
-- Права доступа для табличных пространств: CREATE
-- Для работы теста необходимо, что бы сущестовала директория /var/lib/postgresql/9.6/testspace
--
\i 'support/init.sql'
--
-- Создаем табличное пространство
CREATE TABLESPACE dbspace LOCATION '/var/lib/postgresql/9.6/testspace';
--
-- Подключение пользователя u_0_00
-- Изначально создание объектов в табличном пространстве запрещено
\connect - u_0_00
--
-- Проверка выполнения CREATE
-- ожидается ошибка доступа
CREATE TABLE "Таблица" (id integer NOT NULL) TABLESPACE dbspace;
--
-- Администратор кластера postgres дает право CREATE для пользователя u_0_00
\connect - postgres
GRANT CREATE ON TABLESPACE dbspace TO u_0_00;
--
-- Подключение пользователя u_0_00
\connect - u_0_00
--
-- Проверка выполнения CREATE
-- ожидается успех
CREATE TABLE "Таблица" (id integer NOT NULL) TABLESPACE dbspace;
--
-- Проверяем наличие созданной таблицы
SELECT relname AS "Наименование таблицы" from pg_class WHERE oid = 'Таблица'::regclass::oid;
--
-- Удаление созданных объектов
DROP TABLE "Таблица";
\connect - postgres
DROP TABLESPACE dbspace;
--
\i 'support/done.sql'
