-- RBT-TEST - MAC LABEL ON ..., MAC CCR ON ...
-- Проверка работы команд назначения мандатных атрибутов MAC LABEL ON ... , MAC CCR ON ...
--
\i 'support/init.sql'
\i 'support/init-mac.sql'
--
-- Создаем пользовательские объекты
\i 'support/create-objects.sql'
--
-- Модифицируем пользовательские объекты
\connect - postgres
--
-- Назначаем метку на кластер
MAC LABEL ON CLUSTER IS '{10,1FFFFFFFFFFFFFFF}';
--
ALTER TABLE table_u_1_01 ADD COLUMN data2 TEXT CHECK (data2 <> '12');
ALTER TABLE table_u_1_01 ADD COLUMN FL2 float DEFAULT 120;
ALTER TABLE table_u_1_01 RENAME COLUMN data TO data1;
ALTER TABLE table_u_1_01 ADD CONSTRAINT table_u_1_01_u UNIQUE (FL2);
--
ALTER TYPE type_u_1_01_c ADD ATTRIBUTE f3 INTEGER;
ALTER TYPE type_u_1_01_e ADD VALUE 'Третий';
ALTER DOMAIN type_u_1_01_d ADD CHECK (VALUE ~ '^\d{4}$');
--
-- Вставляем запись в таблицу pg_largeobject с меткой {0,0} для объекта 200000
INSERT INTO pg_largeobject(loid, pageno, data) VALUES(200000, 1, 'test');
--
ALTER DEFAULT PRIVILEGES FOR ROLE group1 REVOKE ALL ON TABLES FROM PUBLIC;
ALTER DEFAULT PRIVILEGES FOR ROLE group1 IN SCHEMA public REVOKE ALL ON TABLES FROM PUBLIC;
ALTER DEFAULT PRIVILEGES FOR ROLE group1 IN SCHEMA "Схема_1_01" REVOKE ALL ON TABLES FROM PUBLIC;
ALTER DEFAULT PRIVILEGES FOR ROLE group1 IN SCHEMA "Схема_1_01", public GRANT ALL ON TABLES TO PUBLIC;
--
ALTER TEXT SEARCH CONFIGURATION tsc_u_1_01 DROP MAPPING FOR numword;
ALTER TEXT SEARCH CONFIGURATION tsc_u_1_01 ADD MAPPING FOR numword WITH english_stem;
--
DROP USER MAPPING FOR GROUP1 SERVER srv_u_1_01;
CREATE USER MAPPING FOR GROUP1 SERVER srv_u_1_01 OPTIONS (user 'group1', password 'secret');
--
-- Проверяем пользовательские объекты
\i 'support/check-objects.sql'
--
-- Проверяем изменение мандатной метки от имени пользователя u_1_01
-- Ожидается отказ доступа
\connect - u_1_01
MAC LABEL ON DATABASE mtest IS '{9,1FFFFFFFFFFFFFFF}';
MAC LABEL ON ROLE GROUP1 IS '{2,1}';
MAC LABEL ON SCHEMA public IS '{8,1FFFFFFFFFFFFFFF}';
MAC LABEL ON TABLE table_u_1_01 IS '{2,2}';
MAC LABEL ON VIEW view_u_1_01 IS '{2,3}';
MAC LABEL ON MATERIALIZED VIEW matview_u_1_01_2 IS '{2,3}';
MAC LABEL ON SEQUENCE seq_u_1_01 IS '{2,4}';
MAC LABEL ON TYPE type_u_1_01_c IS '{2,5}';
MAC LABEL ON TYPE type_u_1_01_e IS '{2,6}';
MAC LABEL ON TYPE type_u_1_01_r IS '{2,7}';
MAC LABEL ON TYPE type_u_1_01_d IS '{2,8}';
MAC LABEL ON LANGUAGE plpgsql IS '{2,1F}';
--
-- Проверяем изменение мандатной метки от имени пользователя dbsa с привилегией назначения метки
-- Ожидается отказ доступа
\connect - dbsa
MAC LABEL ON DATABASE mtest IS '{9,1FFFFFFFFFFFFFFF}';
MAC LABEL ON ROLE GROUP1 IS '{2,1}';
MAC LABEL ON SCHEMA public IS '{8,1FFFFFFFFFFFFFFF}';
MAC LABEL ON TABLE table_u_1_01 IS '{2,2}';
MAC LABEL ON VIEW view_u_1_01 IS '{2,3}';
MAC LABEL ON MATERIALIZED VIEW matview_u_1_01_2 IS '{2,3}';
MAC LABEL ON SEQUENCE seq_u_1_01 IS '{2,4}';
MAC LABEL ON TYPE type_u_1_01_c IS '{2,5}';
MAC LABEL ON TYPE type_u_1_01_e IS '{2,6}';
MAC LABEL ON TYPE type_u_1_01_r IS '{2,7}';
MAC LABEL ON TYPE type_u_1_01_d IS '{2,8}';
MAC LABEL ON LANGUAGE plpgsql IS '{2,1F}';
--
\connect - postgres
-- Назначаем метку {2,3} на табличное пространство dbspace
-- Ожидается успех
MAC LABEL ON TABLESPACE dbspace IS '{2,3}';
-- Создадим объекты в табличном пространстве dbspace
CREATE TABLE "Таблица" ("Идентификатор" INTEGER, "Данные" TEXT) WITH (MACS=TRUE) TABLESPACE dbspace;
-- Устанавливаем метку на таблицу {2,3}
-- Ожидается успех
MAC LABEL ON TABLE "Таблица" IS '{2,3}';
-- Снимаем флаг CCR с таблицы
-- Ожидается успех
MAC CCR ON TABLE "Таблица" IS OFF;
-- Заполняем таблицу данными и устанавливаем записям различные метки
INSERT INTO "Таблица" VALUES(1, 'Данные 1');
INSERT INTO "Таблица" VALUES(2, 'Данные 2');
INSERT INTO "Таблица" VALUES(3, 'Данные 3');
CHMAC "Таблица" SET maclabel = '{0,1}' WHERE "Идентификатор" = 1;
CHMAC "Таблица" SET maclabel = '{0,3}' WHERE "Идентификатор" = 2;
CHMAC "Таблица" SET maclabel = '{1,2}' WHERE "Идентификатор" = 3;
-- Проверяем невозможность занижения метки на контейнеры
-- База данных mtest содержит объекты, метка которых > {8,0}
-- например, метка схемы public, которая содержится в mtest {8,1FFFFFFFFFFFFFFF}
-- Ожидается отказ
MAC LABEL ON DATABASE mtest IS '{8,0}';
-- Назначаем метку {8,1FFFFFFFFFFFFFFF} на mtest
-- Ожидается успех
MAC LABEL ON DATABASE mtest IS '{8,1FFFFFFFFFFFFFFF}';
-- Схема public содержит в себе объекты, метка которых > {0,0}
-- например, таблица blob_u_1_01 имеет метку {1,1}
-- Ожидается отказ
MAC LABEL ON SCHEMA public IS '{0,0}';
-- Назначаем метку {2,1F} на схему
-- Ожидается успех
MAC LABEL ON SCHEMA public IS '{2,1F}';
-- Назначаем метку {0,2} на dbspace
-- Ожидается отказ
-- в табличном пространстве dbspace создана таблица "Таблица" с меткой {2,3}
MAC LABEL ON TABLESPACE dbspace IS '{0,2}';
-- Назначаем метку {2,3} на dbspace
-- Ожидается успех
MAC LABEL ON TABLESPACE dbspace IS '{2,3}';
-- Назначаем метку на таблицу {1,0}
-- Ожидается отказ
-- Записи таблицы "Таблица" имеет аккумулирующую метку {1,3}
MAC LABEL ON TABLE "Таблица" IS '{1,0}';
-- Назначаем метку на таблицу {1,3}
-- Ожидается успех
MAC LABEL ON TABLE "Таблица" IS '{1,3}';
--
DROP TABLE "Таблица";
--
-- Изменяем мандатную метку объектов
MAC LABEL ON DATABASE mtest IS '{9,1FFFFFFFFFFFFFFF}';
MAC LABEL ON ROLE GROUP1 IS '{1,0}';
MAC LABEL ON SCHEMA public IS '{8,1FFFFFFFFFFFFFFF}';
MAC LABEL ON TABLE table_u_1_01 IS '{2,1}';
MAC LABEL ON TABLE table_u_1_01_С IS '{2,2}';
MAC LABEL ON VIEW view_u_1_01 IS '{2,3}';
MAC LABEL ON MATERIALIZED VIEW matview_u_1_01_2 IS '{2,3}';
MAC LABEL ON SEQUENCE seq_u_1_01 IS '{2,4}';
MAC LABEL ON TYPE type_u_1_01_c IS '{2,5}';
MAC LABEL ON TYPE type_u_1_01_e IS '{2,6}';
MAC LABEL ON TYPE type_u_1_01_r IS '{2,7}';
MAC LABEL ON DOMAIN type_u_1_01_d IS '{2,1}';
MAC LABEL ON FUNCTION func_u_1_01() IS '{2,9}';
MAC LABEL ON TRIGGER trg_u_1_01 ON table_u_1_01 IS '{2,A}';
MAC LABEL ON AGGREGATE agg_u_1_01(float8) IS '{2,B}';
MAC LABEL ON CAST (maclabel AS varchar) IS '{2,C}';
MAC LABEL ON COLLATION rus_u_1_01 IS '{2,D}';
MAC LABEL ON CONVERSION conv_u_1_01 IS '{2,E}';
MAC LABEL ON SERVER srv_u_1_01 IS '{2,F}';
MAC LABEL ON FOREIGN TABLE ftbl_u_1_01 IS '{2,10}';
MAC LABEL ON LARGE OBJECT 200000 IS '{2,11}';
MAC LABEL ON OPERATOR FAMILY opf1 USING btree IS '{2,12}';
MAC LABEL ON OPERATOR CLASS opc1 USING btree  IS '{2,13}';
MAC LABEL ON OPERATOR ##(path,path) IS '{2,14}';
MAC LABEL ON TEXT SEARCH PARSER tsp1 IS '{2,15}';
MAC LABEL ON TEXT SEARCH TEMPLATE tst1 IS '{2,16}';
MAC LABEL ON TEXT SEARCH DICTIONARY tsd_u_1_01 IS '{2,17}';
MAC LABEL ON TEXT SEARCH CONFIGURATION tsc_u_1_01 IS '{2,18}';
MAC LABEL ON TABLESPACE dbspace IS '{2,1C}';
MAC LABEL ON EXTENSION adminpack IS '{2,1D}';
MAC LABEL ON FOREIGN DATA WRAPPER dummy IS '{2,1E}';
MAC LABEL ON LANGUAGE plpgsql IS '{2,1F}';
MAC LABEL ON EVENT TRIGGER ev_trigger IS '{2,1F}';
--
-- Проверяем пользовательские объекты
-- Ожидается, что они приобрели новую метку
\i 'support/check-objects.sql'
--
\i 'support/delete-objects.sql'
\i 'support/done.sql'
\i 'support/reset-cluster-mac-attributes.sql'
