-- RBT-TEST - COPY TO STDOUT WITH MACS
-- Проверка работы МПРД при использовании команды COPY TO STDOUT WITH MACS
--
\i 'support/init.sql'
\i 'support/init-mac.sql'
\i 'support/create-test-table.sql'
\i 'support/init-test-table.sql'
--
-- Проверка тестовой таблицы
SELECT maclabel, * FROM "Проверка";
--
-- Подключение пользователя u_0_00 c меткой {0,0}
\connect - u_0_00
--
-- Попытка выполнить команду COPY на экран
-- Ожидается две строки с метками {0,0}, при этом метки не выводятся
COPY "Проверка" TO STDOUT;
--
-- Попытка выполнить команду COPY с выводом меток на экран
-- Ожидается две строки с метками {0,0}, метки так же выводятся
COPY "Проверка" TO STDOUT WITH MACS;
--
-- Подключается пользователь dbsa с флагами игнорирования МПРД
\connect - dbsa
--
-- Попытка выполнить команду COPY с выводом меток на экран
-- Ожидаются все 10 строк
COPY "Проверка" TO STDOUT WITH MACS;
--
-- Подключается суперюзер postgres
\connect - postgres
--
-- Очищаем таблицу
DELETE FROM "Проверка";
--
-- Устанавливаем метку таблицы в {1,1}
MAC LABEL ON TABLE "Проверка" IS '{1, 1}';
--
-- Пытаемся заполнить таблицу со стандартного потока ввода
-- пользователем u_0_00
-- ожидается успех
\connect - u_0_00
COPY "Проверка" FROM STDIN;
1   u_0_00
\.
--
-- пользователем u_1_01
-- ожидается успех
\connect - u_1_01
COPY "Проверка" FROM STDIN;
2   u_1_01
\.
--
-- пользователем u_2_11
-- ожидается ошибка доступа
\connect - u_2_11
COPY "Проверка" FROM STDIN;
--
-- пользователем dbsa
-- ожидается ошибка доступа (превышение метки таблицы)
\connect - dbsa
COPY "Проверка" FROM STDIN;
3   dbsa-max
\.
--
-- Проверяем невозможность вставки метки пользователем без привилегии назначения метки CHMAC
-- Ожидается ошибка доступа
\connect - u_1_01
COPY "Проверка" FROM STDIN WITH MACS;
--
-- Проверяем возможность вставки метки пользователем с привилегией назначения метки CHMAC
-- Ожидается успех
\connect - dbsa
COPY "Проверка" FROM STDIN WITH MACS;
{1,0}   4   dbsa-1_00
\.
--
-- Проверяем возможность вставки метки пользователем с привилегией назначения метки CHMAC
-- данных с меткой, превышающей метку таблицы
-- Ожидается успех
\connect - dbsa
COPY "Проверка" FROM STDIN WITH MACS;
{2,0}   5   dbsa-2_00
\.
--
-- Проверяем содержимое таблицы
-- Ожидаются 3 строки
SELECT maclabel,* FROM "Проверка" ORDER BY "идентификатор";
--
-- Проверяем таблицу с признаком MAC CCR
-- Создаем от имени пользователя u_1_01 таблицу с меткой {1, 1}
\connect - u_1_01
CREATE TABLE "Схема_1_01"."Проверка_1_01" ("идентификатор" INTEGER PRIMARY KEY, "данные" TEXT);
GRANT ALL ON "Схема_1_01"."Проверка_1_01" TO PUBLIC;
--
-- Пытаемся заполнить таблицу со стандартного потока ввода
-- пользователем u_0_00
-- ожидается ошибка доступа
\connect - u_0_00
COPY "Схема_1_01"."Проверка_1_01" FROM STDIN;
--
-- пользователем u_1_01
-- ожидается успех
\connect - u_1_01
COPY "Схема_1_01"."Проверка_1_01" FROM STDIN;
2   u_1_01
\.
--
-- пользователем u_2_11
-- ожидается ошибка доступа
\connect - u_2_11
COPY "Схема_1_01"."Проверка_1_01" FROM STDIN;
--
-- Проверяем содержимое таблицы
-- Ожидаются 1 строка
SELECT * FROM "Схема_1_01"."Проверка_1_01" ORDER BY "идентификатор";
--
\i 'support/done.sql'
\i 'support/reset-cluster-mac-attributes.sql'