-- RBT-TEST - МПРД при создании объектов
-- Проверка работы МПРД в разных режимах создания объектов
--
\i 'support/init.sql'
\i 'support/init-mac.sql'
--
-- Создаем объекты БД
\i 'support/create-objects.sql'
--
\connect mtest postgres
-- Удаляем правило
DROP RULE IF EXISTS table_u_1_01_RU ON table_u_1_01;
-- Создаем правило для операции UPDATE
CREATE RULE table_u_1_01_RU AS ON UPDATE TO table_u_1_01
        WHERE NEW.ID > 28 DO ALSO
    UPDATE table_u_1_01 SET FL = FL + NEW.ID
    WHERE ID = NEW.ID-1;
COMMENT ON RULE table_u_1_01_RU ON table_u_1_01 IS 'Правило table_u_1_01_RU';
-- Удаляем триггер
DROP TRIGGER IF EXISTS trg_u_1_01 ON table_u_1_01;
-- Создаем триггер
CREATE TRIGGER trg_u_1_01
  BEFORE UPDATE
  ON table_u_1_01
  FOR EACH ROW
  EXECUTE PROCEDURE func_u_1_01();
COMMENT ON TRIGGER trg_u_1_01 ON table_u_1_01 IS 'Триггер u_1_01';
--
-- Проверяем объекты БД
-- Ожидается, что метки созданных объектов соответствует метке создавшего пользователя
-- или заданных администратором кластера postgres
\i 'support/check-objects.sql'
--
\i 'support/delete-objects.sql'
\i 'support/done.sql'
\i 'support/reset-cluster-mac-attributes.sql'