-- RBT-TEST - Проверка ограничений ДП-модели
-- Проверка ограничений ДП-модели
--
\i 'support/init.sql'
\i 'support/init-mac.sql'
\i 'support/init-config-tools.sql'
--
-- Подключаемся к базе данных mtest
\connect mtest
--
-- Создаем тестовые таблицы
CREATE TABLE "Проверка_WITH_MACS"("Идентификатор" INTEGER NOT NULL PRIMARY KEY, "Данные" TEXT) WITH (MACS=TRUE);
CREATE TABLE "Проверка_WITHOUT_MACS"("Идентификатор" INTEGER NOT NULL PRIMARY KEY, "Данные" TEXT);
CREATE TABLE "Проверка" ("Идентификатор" INTEGER NOT NULL PRIMARY KEY, "Данные" TEXT);
-- Создаем табличное пространство dbspace
CREATE TABLESPACE dbspace LOCATION '/var/lib/postgresql/9.6/testspace';
-- Перемещаем таблицу "Проверка" в табличное пространство dbspace
ALTER TABLE "Проверка" SET TABLESPACE dbspace;
-- Выдаем права на эти таблицы пользователю PUBLIC
GRANT ALL ON TABLE "Проверка_WITH_MACS" TO PUBLIC;
GRANT ALL ON TABLE "Проверка_WITHOUT_MACS" TO PUBLIC;
-- Устанавливаем метки таблицам {2,3}
-- Ожидается успех
MAC LABEL ON TABLE "Проверка_WITH_MACS" IS '{2,3}';
MAC LABEL ON TABLE "Проверка_WITHOUT_MACS" IS '{1,1}';
-- Снимаем флаг CCR с таблиц
-- Ожидается успех
MAC CCR ON TABLE "Проверка_WITH_MACS" IS OFF;
-- Заполняем таблицу "Проверка_WITH_MACS" данными от разных пользователей
\connect - u_0_00
INSERT INTO "Проверка_WITH_MACS" VALUES(1, 'Данные ' || USER);
\connect - u_0_01
INSERT INTO "Проверка_WITH_MACS" VALUES(2, 'Данные ' || USER);
\connect - u_1_01
INSERT INTO "Проверка_WITH_MACS" VALUES(3, 'Данные ' || USER);
\connect - u_0_10
INSERT INTO "Проверка_WITH_MACS" VALUES(4, 'Данные ' || USER);
\connect - u_1_10
INSERT INTO "Проверка_WITH_MACS" VALUES(5, 'Данные ' || USER);
\connect - u_1_11
INSERT INTO "Проверка_WITH_MACS" VALUES(6, 'Данные ' || USER);
\connect - u_2_11
INSERT INTO "Проверка_WITH_MACS" VALUES(7, 'Данные ' || USER);
-- Заполняем таблицу "Проверка_WITHOUT_MACS" данными от пользователя u_1_01
\connect - u_1_01
INSERT INTO "Проверка_WITHOUT_MACS" VALUES(1, 'Данные ' || USER);
INSERT INTO "Проверка_WITHOUT_MACS" VALUES(2, 'Данные ' || USER);
INSERT INTO "Проверка_WITHOUT_MACS" VALUES(3, 'Данные ' || USER);
INSERT INTO "Проверка_WITHOUT_MACS" VALUES(4, 'Данные ' || USER);
INSERT INTO "Проверка_WITHOUT_MACS" VALUES(5, 'Данные ' || USER);
INSERT INTO "Проверка_WITHOUT_MACS" VALUES(6, 'Данные ' || USER);
INSERT INTO "Проверка_WITHOUT_MACS" VALUES(7, 'Данные ' || USER);
-- Подключаемся как пользователь postgres
\connect - postgres
--
-- Просматриваем содержимое таблиц
--
-- Просматриваем содержимое таблицы "Проверка_WITH_MACS"
-- Ожидается 7 записей с мандатными метками, соответствующие уровню пользователя
SELECT maclabel AS "Мандатная метка", * FROM "Проверка_WITH_MACS";
-- Просматриваем содержимое таблицы "Проверка_WITHOUT_MACS"
-- Ожидается 7 записей
SELECT * FROM "Проверка_WITHOUT_MACS";
--
-- Изменяем (понижаем) мандатную метку объектов
--
-- Ожидается отказ доступа
-- Т.к. таблица содержит записи превосходящие {2,2}
MAC LABEL ON TABLE "Проверка_WITH_MACS" IS '{2,2}';
-- Т.к. схема содержит таблицы "Проверка_WITH_MACS" и "Проверка_WITHOUT_MACS", с меткой {2,3}
MAC LABEL ON SCHEMA public IS '{2,2}';
-- Т.к. база данных содержит схему public с меткой {2,3}
MAC LABEL ON DATABASE mtest IS '{2,2}';
-- Т.к. кластер содержит базу данных mtest cо схемой public, метка которой {2,3}
MAC LABEL ON CLUSTER IS '{2,2}';
--
-- Понижаем метку таблицы "Проверка_WITHOUT_MACS"
-- Ожидается успех, т.к. отсутствуют метки на записях
MAC LABEL ON TABLE "Проверка_WITHOUT_MACS" IS '{0,0}';
--
-- Изменяем (повышаем) мандатную метку объектов
--
-- Ожидается отказ доступа
-- Т.к. запись содержится в таблице "Проверка_WITH_MACS", метка которой равна {2,3}
CHMAC "Проверка_WITH_MACS" SET maclabel = '{3,4}' WHERE "Идентификатор" = 1;
-- Т.к. таблица "Проверка_WITH_MACS" находится в схеме "public", метка которой {2,3}
MAC LABEL ON TABLE "Проверка_WITH_MACS" IS '{3,4}';
-- Т.к. схема "public" содержится в базе данных "mtest", метка которой {2,3}
MAC LABEL ON SCHEMA public IS '{3,4}';
-- Т.к. база данных "mtest" содержится в кластере, метка которого {3,3}
MAC LABEL ON DATABASE mtest IS '{3,4}';
--
-- Повышаем метку базы данных "mtest" до метки кластера
-- Ожидается успех
MAC LABEL ON DATABASE mtest IS '{3,3}';
-- Повышаем метку схемы "public" до метки базы данных "mtest"
-- Ожидается успех
MAC LABEL ON SCHEMA public IS '{3,3}';
-- Повышаем метку таблиц до уровня схемы "public"
-- Ожидается успех
MAC LABEL ON TABLE "Проверка_WITH_MACS" IS '{3,3}';
MAC LABEL ON TABLE "Проверка_WITHOUT_MACS" IS '{3,3}';
-- Изменяем метку первой записи таблицы "Проверка_WITH_MACS" до уровня этой таблицы
-- Ожидается успех
CHMAC "Проверка_WITH_MACS" SET maclabel = '{3,3}' WHERE "Идентификатор" = 1;
--
-- Проверяем мандатную целостность объектов баз данных
-- с установленным параметром ac_auto_adjust_macs
--
-- Включаем параметр ac_enable_auto_adjust_macs

\connect - postgres
-- Создаём функцию для получения OID табличного пространства таблицы
CREATE OR REPLACE FUNCTION get_tablespace_of_table(tblname TEXT)
  RETURNS OID AS
$BODY$
DECLARE
    tableoid OID;
    pg_class_cursor  CURSOR (key TEXT) FOR SELECT reltablespace FROM pg_class WHERE relname = key;
    pg_tablespace_cursor CURSOR FOR SELECT oid FROM pg_tablespace WHERE spcname = 'pg_default';
BEGIN
    OPEN pg_class_cursor(key := tblname);
    FETCH pg_class_cursor INTO tableoid;
    IF tableoid = 0 THEN
        OPEN pg_tablespace_cursor;
        FETCH pg_tablespace_cursor INTO tableoid;
        CLOSE pg_tablespace_cursor;
    END IF;
    CLOSE pg_class_cursor;
    RETURN tableoid;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
-- Выдаём права на использование пользователю PUBLIC
GRANT ALL ON FUNCTION get_tablespace_of_table(TEXT) TO PUBLIC;
\i 'support/enable-auto-adjust-macs.sql'
-- Включённый параметр ac_enable_auto_adjust_macs позволяет повышать/понижать метку на таблицах, материализованных видах, видах и подпоследовательностях,
-- при этом метка на контейнерах будет автоматически поднята при необходимости.
--
-- Просматриваем метки таблиц "Проверка_WITH_MACS", "Проверка_WITHOUT_MACS", "Проверка"
-- Ожидается, что "Проверка_WITH_MACS", "Проверка_WITHOUT_MACS" имеют метку {3,3},
-- таблица "Проверка" имеет метку {0,0}.
SELECT relname, maclabel FROM pg_class WHERE relname LIKE 'Проверка%' AND relkind = 'r' ORDER BY relname;
-- Устанавливаем метку на таблицу "Проверка_WITH_MACS" {5,5}
-- Ожидается повышение метки на таблицу "Проверка_WITH_MACS"
MAC LABEL ON TABLE "Проверка_WITH_MACS" IS '{5,5}';
-- Просматриваем метки таблиц "Проверка_WITH_MACS" и "Проверка_WITHOUT_MACS"
-- Ожидаются метка {3,3} для таблицы "Проверка_WITH_MACS" и {5,7} для таблицы "Проверка_WITHOUT_MACS"
SELECT relname, maclabel FROM pg_class WHERE relname LIKE 'Проверка_%' AND relkind = 'r' ORDER BY relname;
-- Просматриваем метки схем базы данных "mtest"
-- Ожидается метка {0,0} для схем pg_temp_1, pg_toast_temp_1,
-- {1,1} на схеме "Схема_u_1_01", {5,7} на схемах public, information_schema, pg_catalog
SELECT nspname, maclabel FROM pg_namespace ORDER BY nspname;
-- Проматриваем метки баз данных
-- Ожидается {5,7} на базе данных mtest, {0,0} на базах данных postgres, template0, template1
SELECT datname, maclabel FROM pg_database ORDER BY datname;
-- Просмариваем метку кластера
-- Ожидается {5,7}
SELECT cluster_maclabel;
-- Просматриваем метку табличного пространства, в которой содержится таблица "Проверка_WITH_MACS"
-- Ожидается {5,7}
SELECT spcname, maclabel FROM pg_tablespace WHERE oid = (SELECT get_tablespace_of_table('Проверка_WITH_MACS')) ORDER BY spcname;
--
--
-- Просматриваем метки таблиц "Проверка_WITH_MACS", "Проверка_WITHOUT_MACS", "Проверка"
-- Ожидается, что "Проверка_WITH_MACS" имеет метку {5,7},
-- "Проверка_WITHOUT_MACS" имеет метку {3,3},
-- а "Проверка" имеет метку {2,8}.
SELECT relname, maclabel FROM pg_class WHERE relname LIKE 'Проверка%' AND relkind = 'r' ORDER BY relname;
-- Назначаем мандатную метку {2,8} на таблицу "Проверка"
-- Ожидается успех
MAC LABEL ON TABLE "Проверка" IS '{2,8}';
-- Просматриваем метки таблиц "Проверка_WITH_MACS" и "Проверка_WITHOUT_MACS"
-- Ожидаются метка {3,3} для таблицы "Проверка_WITH_MACS" и {5,7} для таблицы "Проверка_WITHOUT_MACS", {2,8} для таблицы "Проверка"
SELECT relname, maclabel FROM pg_class WHERE relname LIKE 'Проверка%' AND relkind = 'r' ORDER BY relname;
-- Просматриваем метки схем базы данных "mtest"
-- Ожидается метка {0,0} для схем pg_temp_1, pg_toast_temp_1,
-- {1,1} на схеме "Схема_u_1_01", {5,F} на схемах public, information_schema, pg_catalog
SELECT nspname, maclabel FROM pg_namespace ORDER BY nspname;
-- Проматриваем метки баз данных
-- Ожидается {5,F} на базе данных mtest, {0,0} на базах данных postgres, template0, template1
SELECT datname, maclabel FROM pg_database ORDER BY datname;
-- Просмариваем метку кластера
-- Ожидается {5,F}
SELECT cluster_maclabel;
-- Просматриваем метку табличного пространства, в которой содержится таблица "Проверка"
-- Ожидается {5,F}
SELECT spcname, maclabel FROM pg_tablespace WHERE oid = (SELECT get_tablespace_of_table('Проверка')) ORDER BY spcname;
--
--
-- Пытаемся понизить метку таблицы "Проверка_WITHOUT_MACS"
-- Ожидается успех
MAC LABEL ON TABLE "Проверка_WITHOUT_MACS" IS '{1,1}';
-- Просматриваем метки таблиц
-- Ожидается изменение метки таблица "Проверка" до {1,1}
SELECT relname, maclabel FROM pg_class WHERE relname LIKE 'Проверка%' AND relkind = 'r' ORDER BY relname;
-- Просматриваем метки схем
-- Ожидается метка {0,0} для схем pg_temp_1, pg_toast_temp_1,
-- {1,1} на схеме "Схема_u_1_01", {5,F} на схемах public, information_schema, pg_catalog
SELECT nspname, maclabel FROM pg_namespace ORDER BY nspname;
-- Проматриваем метки баз данных
-- Ожидается {5,F} на базе данных mtest, {0,0} на базах данных postgres, template0, template1
SELECT datname, maclabel FROM pg_database ORDER BY datname;
-- Просмариваем метку кластера
-- Ожидается {5,F}
SELECT cluster_maclabel;
-- Просматриваем метку табличного пространства, в которой содержится таблица "Проверка"
-- Ожидается {5,F}
SELECT spcname, maclabel FROM pg_tablespace WHERE oid = (SELECT get_tablespace_of_table('Проверка')) ORDER BY spcname;
--
\connect - postgres
-- Выключаем параметр ac_auto_adjust_macs
\i 'support/disable-auto-adjust-macs.sql'
-- Удаляем ранее созданные объекты
DROP FUNCTION get_tablespace_of_table(TEXT);
DROP TABLE "Проверка_WITH_MACS";
DROP TABLE "Проверка_WITHOUT_MACS";
DROP TABLE "Проверка";
DROP TABLESPACE dbspace;
\i 'support/done.sql'
\i 'support/reset-cluster-mac-attributes.sql'