-- RBT-TEST - МПРД для последовательностей
-- Проверка работы МПРД для последовательностей
--
\i 'support/init.sql'
\i 'support/init-mac.sql'
\i 'support/init-config-tools.sql'
\i 'support/disable-sequence-ccr.sql'
--
-- Подключение пользователя u_1_01
\connect - u_1_01
--
-- Создание последовательности
CREATE SEQUENCE "Последовательность"
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
--
-- Отключаем дискреционный контроль доступа
GRANT ALL ON "Последовательность" TO PUBLIC;
--
-- Ожидается, что метка созданной последовательности соответствует метке пользователя {1,1}
-- и записи последовательности незащищены (меток не имеют)
-- признак MAC CCR установлен
SELECT maclabel, relname, relhasmacs, relmacccr
FROM pg_class WHERE relname = 'Последовательность';
--
-- Проверка выполнения SELECT
-- ожидается успех
SELECT * FROM "Последовательность";
--
-- Проверка вызова функции nextval
-- ожидается успех
SELECT nextval('"Последовательность"');
--
-- Проверка вызова функции setval
-- ожидается успех
SELECT setval('"Последовательность"', 100);
--
-- Проверка вызова функции currval
-- ожидается успех
SELECT currval('"Последовательность"');
--
-- Подключение пользователя u_1_11
\connect - u_1_11
--
-- Проверка выполнения SELECT
-- ожидается успех
SELECT * FROM "Последовательность";
--
-- Проверка вызова функции nextval
-- ожидается ошибка доступа
SELECT nextval('"Последовательность"');
--
-- Проверка вызова функции setval
-- ожидается ошибка доступа
SELECT setval('"Последовательность"', 100);
--
-- Проверка вызова функции currval
-- ожидается ошибка
SELECT currval('"Последовательность"');
--
-- Подключение пользователя u_0_00
\connect - u_0_00
--
-- Проверка выполнения SELECT
-- Ожидается ошибка, объект для пользователя недоступен
SELECT * FROM "Последовательность";
--
-- Проверка вызова функции nextval
-- Ожидается ошибка, объект для пользователя недоступен
SELECT nextval('"Последовательность"');
--
-- Проверка вызова функции setval
-- Ожидается ошибка, объект для пользователя недоступен
SELECT setval('"Последовательность"', 100);
--
-- Проверка вызова функции currval
-- Ожидается ошибка, объект для пользователя недоступен
SELECT currval('"Последовательность"');
--
-- Подключаемся как администратор кластера
\connect - postgres
--
-- Сбрасываем признак MAC CСR у последовательности "Последовательность"
-- Ожидается ошибка
MAC CCR ON SEQUENCE "Последовательность" IS OFF;
--
\i 'support/enable-sequence-ccr.sql'
--
-- Сбрасываем признак MAC CСR у последовательности "Последовательность"
-- Ожидается ошибка
MAC CCR ON SEQUENCE "Последовательность" IS OFF;
--
-- Подключение пользователя u_1_11
\connect - u_1_11
--
-- Проверка выполнения SELECT
-- ожидается успех
SELECT * FROM "Последовательность";
--
-- Проверка вызова функции nextval
-- ожидается ошибка доступа
SELECT nextval('"Последовательность"');
--
-- Проверка вызова функции setval
-- ожидается ошибка доступа
SELECT setval('"Последовательность"', 100);
--
-- Проверка вызова функции currval
-- ожидается ошибка
SELECT currval('"Последовательность"');
--
-- Подключение пользователя u_0_00
\connect - u_0_00
--
-- Проверка выполнения SELECT
-- ожидается успех
SELECT * FROM "Последовательность";
--
-- Проверка вызова функции nextval
-- ожидается успех
SELECT nextval('"Последовательность"');
--
-- Проверка вызова функции setval
-- ожидается успех
SELECT setval('"Последовательность"', 100);
--
-- Проверка вызова функции currval
-- ожидается успех
SELECT currval('"Последовательность"');
--
--
\i 'support/done.sql'
\i 'support/reset-cluster-mac-attributes.sql'