-- RBT-TEST - Встроенные функции для типа MACLABEL
-- Проверка работы встроенных функций для типа MACLABEL
--

\i 'support/init.sql'
\i 'support/init-mac.sql'
\i 'support/create-test-table.sql'
--
-- Проверка вызова функции session_maclabel
--
-- Поключаемся как пользователь u_0_00 с меткой {0,0}
\connect - u_0_00
--
-- Проверяем метку сессии, ожидается {0,0}
SELECT session_maclabel;
--
-- Меняем метку сессии на {1,3}
-- ожидается ошибка
SET ac_session_maclabel = '{1,3}';
--
-- Поключаемся как пользователь u_1_10 с меткой {1,2}
\connect - u_1_10
--
-- Проверяем метку сессии, ожидается {1,2}
SELECT session_maclabel;
--
-- Меняем метку сессии на {0,0}
-- ожидается ошибка
SET ac_session_maclabel = '{0,0}';
--
-- Поключаемся как пользователь dbsa с атрибутам игнорирования МПРД
-- и возможностью менять метку сессии
\connect - dbsa
--
-- Проверяем метку сессии, ожидается {7,1fffffffffffffff}
SELECT session_maclabel;
--
-- Меняем метку сессии на {0,0}
SET ac_session_maclabel = '{0,0}';
--
-- Проверяем метку сессии, ожидается {0,0}
SELECT session_maclabel;
--
-- Меняем метку сессии на {1,3}
SET ac_session_maclabel = '{1,3}';
--
-- Проверяем метку сессии, ожидается {1,3}
SELECT session_maclabel;
--
-- Проверка функции maclabel
--
-- Собираем метку из уровня 1 и категории 2
-- Ожидается метка {1,2}
SELECT maclabel(1,2);
--
-- Проверка функции level
--
-- Извлекаем уровень из метки {2, 3}
-- Ожидается уровень 2
SELECT level('{2,3}');
--
-- Проверка функции category
--
-- Извлекаем вектор категорий из метки {2, 3}
-- Ожидается вектор категорий 3
SELECT category('{2,3}');
--
--
-- Проверка функций
--
--
-- Функция накопления метки в таблице
-- Назначаем метку {2,3} на таблицу "Проверка"
-- Ожидается успех
\connect - postgres
MAC LABEL ON TABLE "Проверка" IS '{2,3}';
-- Снимаем флаг CCR с таблицы
-- Ожидается успех
MAC CCR ON TABLE "Проверка" IS OFF;
-- Подключаемся пользователями с разными уровнями и наполняем таблицу
-- u_0_00 метка {0,0}
\connect - u_0_00
INSERT INTO "Проверка" VALUES(1, 'Запись u_0_00');
-- u_0_01 метка {0,1}
\connect - u_0_01
INSERT INTO "Проверка" VALUES(2, 'Запись u_0_01');
-- u_1_01 метка {1,1}
\connect - u_1_01
INSERT INTO "Проверка" VALUES(3, 'Запись u_1_01');
-- u_0_10 метка {0,2}
\connect - u_0_10
INSERT INTO "Проверка" VALUES(4, 'Запись u_0_10');
-- u_1_10 метка {1,2}
\connect - u_1_10
INSERT INTO "Проверка" VALUES(5, 'Запись u_1_10');
-- u_1_11 метка {1,3}
\connect - u_1_11
INSERT INTO "Проверка" VALUES(6, 'Запись u_1_11');
-- u_2_11 метка {2,3}
\connect - u_2_11
INSERT INTO "Проверка" VALUES(7, 'Запись u_2_11');
--
\connect - postgres
-- Убедимся в том, что в таблице 7 записей и их уровни соответствуют уровням пользователей
SELECT maclabel, * FROM "Проверка";
-- Получаем аккумулирующую метку из таблицы с помощью функции supmaclabel()
-- Ожидается {2,3}
SELECT supmaclabel(maclabel) FROM "Проверка";
-- Удаляем записи, идентификатор которых >= 6
-- Ожидается удаление 2 записей
DELETE FROM "Проверка" WHERE "идентификатор" >= 6;
-- Убедимся в том, что в таблице осталось 5 записей
-- Ожидается 5 записи
SELECT maclabel, * FROM "Проверка";
-- Получаем аккумулирующую метку из таблицы
-- Ожидается {1,3}
SELECT supmaclabel(maclabel) FROM "Проверка";
-- Удаляем записи, уровни мандатной метки которой равны 1
-- Ожидается удаление 2 записей
DELETE FROM "Проверка" WHERE level(maclabel) = 1;
-- Убедимся в том, что в таблице осталось 3 записи
-- Ожидается 3 записи
SELECT maclabel, * FROM "Проверка";
-- Получаем аккумулирующую мемтку таблицы
-- Ожидается {0,3}
SELECT supmaclabel(maclabel) FROM "Проверка";
-- Удаляем все записи из таблицы "Проверка"
DELETE FROM "Проверка";
--
--
-- Проверка логических операторов типа maclabel
--
--
-- Наполняем таблицу записями с разным уровнем
\connect - u_0_00
INSERT INTO "Проверка" VALUES(1, 'Запись u_0_00');
-- u_0_01 метка {0,1}
\connect - u_0_01
INSERT INTO "Проверка" VALUES(2, 'Запись u_0_01');
-- u_1_01 метка {1,1}
\connect - u_1_01
INSERT INTO "Проверка" VALUES(3, 'Запись u_1_01');
-- u_0_10 метка {0,2}
\connect - u_0_10
INSERT INTO "Проверка" VALUES(4, 'Запись u_0_10');
-- u_1_10 метка {1,2}
\connect - u_1_10
INSERT INTO "Проверка" VALUES(5, 'Запись u_1_10');
-- u_1_11 метка {1,3}
\connect - u_1_11
INSERT INTO "Проверка" VALUES(6, 'Запись u_1_11');
-- u_2_11 метка {2,3}
\connect - u_2_11
INSERT INTO "Проверка" VALUES(7, 'Запись u_2_11');
--
-- Выводим таблицу операторов сравнения для типа maclabel
SELECT maclabel, (maclabel =  '{1,2}') AS "=",     (maclabel <> '{1,2}') AS "<>",
                 (maclabel <  '{1,2}') AS "<",  NOT(maclabel <  '{1,2}') AS "NOT <",
                 (maclabel <= '{1,2}') AS "<=", NOT(maclabel <= '{1,2}') AS "NOT <=",
                 (maclabel >  '{1,2}') AS ">",  NOT(maclabel >  '{1,2}') AS "NOT >",
                 (maclabel >= '{1,2}') AS ">=", NOT(maclabel >= '{1,2}') AS "NOT >="
FROM "Проверка";
--
\i 'support/done.sql'
\i 'support/reset-cluster-mac-attributes.sql'