-- RBT-TEST - МПРД при использовании политик (POLICY)
-- Проверка сохранения работы МПРД при использовании row-level безопасности (POLICY)
--
\i 'support/init-policy.sql'
--
-- Подключаемся суперпользователем
\connect policy_example postgres;
--
-- ### Проверка групп пользователей ###
-- Роли "Психолог". Ожидается роль p11 и бойцы подразделения p11: b4, b5, b6
select * from user_roles('Психолог') order by user_roles;
--
-- Роли "Военнослужащий". Ожидается роль b1
select * from user_roles('Военнослужащий') order by user_roles;
--
-- Роли "Кадровик". Ожидаются роли: Кадровик
-- Иерархические: n11, n111, n112, n113
-- Линейные: p11, p111, p112, p113
-- Бойцы подразделений n111, n112, n113: b1, b2, b3, b4, b5, b6, b7, b8, b8, b19, b11
select * from user_roles('Кадровик') order by user_roles;
--
-- Проверка принадлежности ролей
-- Есть ли у "Кадровик" роль n11. Ожидается true
select * from is_user_role('Кадровик', 'n11');
--
-- Есть ли у "Кадровик" роль n111. Ожидается true
select * from is_user_role('Кадровик', 'n111');
--
-- Есть ли у "Кадровик" роль n112. Ожидается true
select * from is_user_role('Кадровик', 'n112');
--
-- Есть ли у "Кадровик" роль n113. Ожидается true
select * from is_user_role('Кадровик', 'n113');
--
-- Есть ли у "Кадровик" роль n12. Ожидается false
select * from is_user_role('Кадровик', 'n12');
--
-- Есть ли у "Кадровик" роль n121. Ожидается false
select * from is_user_role('Кадровик', 'n121');
--
-- ### Проводим проверку правильности выборки ###
\connect - b4;
select * from units order by id;
select * from warriors order by unit_id;
select * from units, warriors where warriors.unit_id = units.id order by units.id;
--
\connect - "Психолог";
select * from units order by id;
select * from warriors order by unit_id;
select * from units, warriors where warriors.unit_id = units.id order by units.id;
--
\connect - "Кадровик";
select * from units order by id;
select * from warriors order by unit_id;
select * from units, warriors where warriors.unit_id = units.id order by units.id;
--
\i 'support/remove-policy.sql'