--
-- Функция для отображения опций из таблицы pg_db_roles_settings
--
\connect mtest postgres
-- P.S. в таблице в столбцах setdatabase и setrole содержатся Oid БД и пользователей,
-- которые будут отличаться при запуске/перезапуске теста
CREATE OR REPLACE FUNCTION settings_info()
  RETURNS TABLE(id INTEGER, dbname TEXT, username TEXT, options TEXT) AS
$BODY$
DECLARE
    record RECORD;
    dbname_cursor  CURSOR (key INTEGER) FOR SELECT datname FROM pg_database WHERE oid = key;
    rolname_cursor CURSOR (key integer) FOR SELECT rolname FROM pg_roles WHERE oid = key;
BEGIN
FOR record IN EXECUTE 'SELECT * FROM pg_db_role_setting'
    LOOP
        IF record.setdatabase = 0 THEN
            dbname := 'ВСЕ';
        ELSE
            OPEN dbname_cursor(key := record.setdatabase);
            FETCH dbname_cursor INTO dbname;
            CLOSE dbname_cursor;
        END IF;
        IF record.setrole = 0 THEN
            username := 'ВСЕ';
        ELSE
            OPEN rolname_cursor(key := record.setrole);
            FETCH rolname_cursor INTO username;
            CLOSE rolname_cursor;
        END IF;
        IF record.setrole = 0 AND record.setdatabase = 0 THEN
            id = 4;
        ELSIF record.setrole = 0 THEN
            id = 3;
        ELSIF record.setdatabase = 0 THEN
            id = 2;
        ELSE
            id = 1;
        END IF;
        options := record.setconfig;
        RETURN NEXT;
    END LOOP;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
--
-- Назначаем все права пользователю PUBLIC на функцию
GRANT ALL ON FUNCTION settings_info() TO PUBLIC;
--
-- Создание функции settings_info() завершено
--